<!--
This README describes the package. If you publish this package to pub.dev,
this README's contents appear on the landing page for your package.

For information about how to write a good package README, see the guide for
[writing package pages](https://dart.dev/guides/libraries/writing-package-pages).

For general information about developing packages, see the Dart guide for
[creating packages](https://dart.dev/guides/libraries/create-library-packages)
and the Flutter guide for
[developing packages and plugins](https://flutter.dev/developing-packages).
-->

## Features

store cached varibles

## Getting started

suppose cached data types
```dart
class c0{
  String id;
  int time;
  c0(this.id,this.time);
  c0.fromMap(Map<String,dynamic>m):id=m["id"],time=int.parse("${m["time"]}");
  toMap()=>{"id":id,"time":time};
}

class c1{
  String id;
  String name;
  c1(this.id,this.name);
  c1.fromMap(Map<String,dynamic>m):id=m["id"],name=m["name"];
  toMap()=>{"id":id,"name":name};
}
```

```dart
    final cache=cacheManager({c0:[(c0 x)=>x.toMap(),c0.fromMap]});
    await Future.delayed(Duration(milliseconds: 500));
    cache.check();
    expect(cache.get<c0>("id0"), null);
    cache.addOrUpdate<c0>(c0("id0", 1));
    cache.check();
    expect(cache.get<c0>("id0").toString(), c0("id0", 1));
```

```dart
    final cache=cacheManager({
      c0:[(c0 x)=>x.toMap(),c0.fromMap],
      c1:[(c1 x)=>x.toMap(),c1.fromMap],
    });
    await Future.delayed(Duration(milliseconds: 500));
    cache.check();
    // expect(cache.get<c0>("id0"), null);
    cache.addOrUpdate<c0>(c0("id0", 1));
    cache.addOrUpdate<c1>(c1("id01", "a instance"));
    cache.check();
    cache.update(c1, "id01", {"name":"an instance"});
    print(cache.get<c1>("id01")?.toMap());
    cache.check();
```

## Usage


## Additional information

